3731. 找出缺失的元素(2026.08.04)

给你一个整数数组 nums ,数组由若干 互不相同 的整数组成。

数组 nums 原本包含了某个范围内的 所有整数 。但现在,其中可能 缺失 部分整数。

该范围内的 最小 整数和 最大 整数仍然存在于 nums 中。

返回一个 有序 列表,包含该范围内缺失的所有整数,并 按从小到大排序 。如果没有缺失的整数,返回一个 空 列表。

示例 1:

输入: nums = 1,4,2,5

输出: 3

解释:

最小整数为 1,最大整数为 5,因此完整的范围应为 1,2,3,4,5。其中只有 3 缺失。

示例 2:

输入: nums = 7,8,6,9

输出: \[\]

解释:

最小整数为 6,最大整数为 9,因此完整的范围为 6,7,8,9。所有整数均已存在,因此没有缺失的整数。

示例 3:

输入: nums = 5,1

输出: 2,3,4

解释:

最小整数为 1,最大整数为 5,因此完整的范围应为 1,2,3,4,5。缺失的整数为 2、3 和 4。

提示:

  • 2 <= nums.length <= 100
  • 1 <= nums[i] <= 100

苯人思路

将排好序的 nums 和范围内所有整数构成的数组 mid 元素一一比较

若访问到 nums 的元素和 mid 的元素不一致(即 nums 缺失该元素),则把该元素加入到 answer 数组中

cpp 复制代码
class Solution {
public:
    vector<int> findMissingElements(vector<int>& nums) {
        int n = nums.size();
        sort(nums.begin(), nums.end());
        int min = nums[0];
        int max = nums[n-1];
        int offset = max-min+1;

        if(n==offset) return {};
        vector<int> mid(offset);
        iota(mid.begin(), mid.begin()+offset, min);
        
        vector<int> answer;
        int i=0, j=0;
        while(j<offset){
            if(nums[i]!=mid[j]){
                answer.emplace_back(mid[j]);
                j++;
            }
            else{
                i++;
                j++;
            }
        }

        return answer;
    }
};
相关推荐
another heaven3 分钟前
【C/C++ C++ 新特性中的那些内存优化的特性】
c语言·开发语言·c++
ysu_031414 分钟前
【C++ 进阶之路】(二)从内联函数到类与对象:深挖内存对齐、this 指针与三大默认成员函数
开发语言·数据结构·c++·笔记·面向对象·this
布莱克60520 分钟前
C++ 中 set 与 map 的区别详解
开发语言·c++·算法·哈希
我叫洋洋24 分钟前
Allegro 画布“垃圾显示“清理指南:把板子调成干净工作台(实战总结)
c语言·c++·单片机·嵌入式硬件·eda·嘉立创
Nuanyt34 分钟前
LeetCode Hot 100 · 双指针 3 题 Java
java·笔记·算法·leetcode·双指针
jimy11 小时前
构造函数表达式的值类别是:prvalue
开发语言·c++
wuminyu1 小时前
JVM规范学习总结-Class文件结构
java·linux·c语言·jvm·c++
多弗朗皮卡丘1 小时前
C++特殊类设计
开发语言·c++·设计模式
文丑颜不良啊2 小时前
LeetCode851~875题目解析
java·leetcode
Navigator_Z2 小时前
LeetCode //C - 1304. Find N Unique Integers Sum up to Zero
c语言·算法·leetcode